Index: NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/diaobs.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/diaobs.F90	(revision 15731)
+++ NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/diaobs.F90	(revision 15799)
@@ -26,25 +26,28 @@
    !!   fin_date      : Compute the final date YYYYMMDD.HHMMSS
    !!----------------------------------------------------------------------
-   USE par_kind       ! Precision variables
-   USE in_out_manager ! I/O manager
-   USE par_oce        ! ocean parameter
-   USE dom_oce        ! Ocean space and time domain variables
-   USE sbc_oce        ! Sea-ice fraction
+   USE par_kind          ! Precision variables
+   USE in_out_manager    ! I/O manager
+   USE timing            ! Timing
+   USE par_oce           ! ocean parameter
+   USE dom_oce           ! Ocean space and time domain variables
+   USE sbc_oce           ! Sea-ice fraction
    !
-   USE obs_read_prof  ! Reading and allocation of profile obs
-   USE obs_read_surf  ! Reading and allocation of surface obs
-   USE obs_sstbias    ! Bias correction routine for SST 
-   USE obs_readmdt    ! Reading and allocation of MDT for SLA.
-   USE obs_prep       ! Preparation of obs. (grid search etc).
-   USE obs_oper       ! Observation operators
-   USE obs_write      ! Writing of observation related diagnostics
-   USE obs_grid       ! Grid searching
-   USE obs_read_altbias ! Bias treatment for altimeter
-   USE obs_profiles_def ! Profile data definitions
-   USE obs_surf_def   ! Surface data definitions
-   USE obs_types      ! Definitions for observation types
+   USE obs_read_prof     ! Reading and allocation of profile obs
+   USE obs_read_surf     ! Reading and allocation of surface obs
+   USE obs_bias          ! Bias correction routine
+   USE obs_readmdt       ! Reading and allocation of MDT for SLA.
+   USE obs_readsnowdepth ! Get model snow depth for conversion of freeboard to ice thickness
+   USE obs_prep          ! Preparation of obs. (grid search etc).
+   USE obs_oper          ! Observation operators
+   USE obs_write         ! Writing of observation related diagnostics
+   USE obs_grid          ! Grid searching
+   USE obs_read_altbias  ! Bias treatment for altimeter
+   USE obs_profiles_def  ! Profile data definitions
+   USE obs_surf_def      ! Surface data definitions
+   USE obs_types         ! Definitions for observation types
+   USE obs_group_def     ! Definitions for observation groups
    !
-   USE mpp_map        ! MPP mapping
-   USE lib_mpp        ! For ctl_warn/stop
+   USE mpp_map           ! MPP mapping
+   USE lib_mpp           ! For ctl_warn/stop
 
    IMPLICIT NONE
@@ -54,45 +57,11 @@
    PUBLIC dia_obs          ! Compute model equivalent to observations
    PUBLIC dia_obs_wri      ! Write model equivalent to observations
-   PUBLIC dia_obs_dealloc  ! Deallocate dia_obs data
    PUBLIC calc_date        ! Compute the date of a timestep
 
-   LOGICAL, PUBLIC :: ln_diaobs          !: Logical switch for the obs operator
-   LOGICAL         :: ln_sstnight        !  Logical switch for night mean SST obs
-   LOGICAL         :: ln_sla_fp_indegs   !  T=> SLA obs footprint size specified in degrees, F=> in metres
-   LOGICAL         :: ln_sst_fp_indegs   !  T=> SST obs footprint size specified in degrees, F=> in metres
-   LOGICAL         :: ln_sss_fp_indegs   !  T=> SSS obs footprint size specified in degrees, F=> in metres
-   LOGICAL         :: ln_sic_fp_indegs   !  T=> sea-ice obs footprint size specified in degrees, F=> in metres
-
-   REAL(wp) ::   rn_sla_avglamscl   ! E/W diameter of SLA observation footprint (metres)
-   REAL(wp) ::   rn_sla_avgphiscl   ! N/S diameter of SLA observation footprint (metres)
-   REAL(wp) ::   rn_sst_avglamscl   ! E/W diameter of SST observation footprint (metres)
-   REAL(wp) ::   rn_sst_avgphiscl   ! N/S diameter of SST observation footprint (metres)
-   REAL(wp) ::   rn_sss_avglamscl   ! E/W diameter of SSS observation footprint (metres)
-   REAL(wp) ::   rn_sss_avgphiscl   ! N/S diameter of SSS observation footprint (metres)
-   REAL(wp) ::   rn_sic_avglamscl   ! E/W diameter of sea-ice observation footprint (metres)
-   REAL(wp) ::   rn_sic_avgphiscl   ! N/S diameter of sea-ice observation footprint (metres)
-
-   INTEGER :: nn_1dint       ! Vertical interpolation method
-   INTEGER :: nn_2dint       ! Default horizontal interpolation method
-   INTEGER :: nn_2dint_sla   ! SLA horizontal interpolation method 
-   INTEGER :: nn_2dint_sst   ! SST horizontal interpolation method 
-   INTEGER :: nn_2dint_sss   ! SSS horizontal interpolation method 
-   INTEGER :: nn_2dint_sic   ! Seaice horizontal interpolation method 
-   INTEGER, DIMENSION(imaxavtypes) ::   nn_profdavtypes   ! Profile data types representing a daily average
-   INTEGER :: nproftypes     ! Number of profile obs types
-   INTEGER :: nsurftypes     ! Number of surface obs types
-   INTEGER , DIMENSION(:), ALLOCATABLE ::   nvarsprof, nvarssurf   ! Number of profile & surface variables
-   INTEGER , DIMENSION(:), ALLOCATABLE ::   nextrprof, nextrsurf   ! Number of profile & surface extra variables
-   INTEGER , DIMENSION(:), ALLOCATABLE ::   n2dintsurf             ! Interpolation option for surface variables
-   REAL(wp), DIMENSION(:), ALLOCATABLE ::   zavglamscl, zavgphiscl ! E/W & N/S diameter of averaging footprint for surface variables
-   LOGICAL , DIMENSION(:), ALLOCATABLE ::   lfpindegs              ! T=> surface obs footprint size specified in degrees, F=> in metres
-   LOGICAL , DIMENSION(:), ALLOCATABLE ::   llnightav              ! Logical for calculating night-time averages
-
-   TYPE(obs_surf), PUBLIC, POINTER, DIMENSION(:) ::   surfdata     !: Initial surface data
-   TYPE(obs_surf), PUBLIC, POINTER, DIMENSION(:) ::   surfdataqc   !: Surface data after quality control
-   TYPE(obs_prof), PUBLIC, POINTER, DIMENSION(:) ::   profdata     !: Initial profile data
-   TYPE(obs_prof), PUBLIC, POINTER, DIMENSION(:) ::   profdataqc   !: Profile data after quality control
-
-   CHARACTER(len=6), PUBLIC, DIMENSION(:), ALLOCATABLE ::   cobstypesprof, cobstypessurf   !: Profile & surface obs types
+   LOGICAL, PUBLIC :: ln_diaobs            !: Logical switch for the obs operator
+   
+   INTEGER :: nn_obsgroups
+
+   TYPE(obs_group), DIMENSION(:), ALLOCATABLE ::   sobsgroups   ! Obs groups
 
    !!----------------------------------------------------------------------
@@ -114,72 +83,33 @@
       !!
       !!----------------------------------------------------------------------
-      INTEGER, PARAMETER ::   jpmaxnfiles = 1000    ! Maximum number of files for each obs type
-      INTEGER, DIMENSION(:), ALLOCATABLE ::   ifilesprof, ifilessurf   ! Number of profile & surface files
+#if defined key_si3
+      USE ice, ONLY : &     ! Sea ice variables
+         & hm_s             ! Snow depth for freeboard conversion
+#elif defined key_cice
+      USE sbc_oce, ONLY : & ! Sea ice variables
+         & thick_s          ! Snow depth for freeboard conversion
+#endif
+      USE obs_fbm, ONLY : &
+         & fbrmdi           ! Real missing data indicator
+
+      IMPLICIT NONE
+
+      INTEGER, PARAMETER ::   jpmaxngroups = 1000    ! Maximum number of obs groups
       INTEGER :: ios             ! Local integer output status for namelist read
       INTEGER :: jtype           ! Counter for obs types
       INTEGER :: jvar            ! Counter for variables
       INTEGER :: jfile           ! Counter for files
-      INTEGER :: jnumsstbias
+      INTEGER :: jenabled
+      INTEGER :: jgroup
       !
-      CHARACTER(len=128), DIMENSION(jpmaxnfiles) :: &
-         & cn_profbfiles, &      ! T/S profile input filenames
-         & cn_sstfbfiles, &      ! Sea surface temperature input filenames
-         & cn_sssfbfiles, &      ! Sea surface salinity input filenames
-         & cn_slafbfiles, &      ! Sea level anomaly input filenames
-         & cn_sicfbfiles, &      ! Seaice concentration input filenames
-         & cn_velfbfiles, &      ! Velocity profile input filenames
-         & cn_sstbiasfiles      ! SST bias input filenames
-      CHARACTER(LEN=128) :: &
-         & cn_altbiasfile        ! Altimeter bias input filename
-      CHARACTER(len=128), DIMENSION(:,:), ALLOCATABLE :: &
-         & clproffiles, &        ! Profile filenames
-         & clsurffiles           ! Surface filenames
-         !
-      LOGICAL :: ln_t3d          ! Logical switch for temperature profiles
-      LOGICAL :: ln_s3d          ! Logical switch for salinity profiles
-      LOGICAL :: ln_sla          ! Logical switch for sea level anomalies 
-      LOGICAL :: ln_sst          ! Logical switch for sea surface temperature
-      LOGICAL :: ln_sss          ! Logical switch for sea surface salinity
-      LOGICAL :: ln_sic          ! Logical switch for sea ice concentration
-      LOGICAL :: ln_vel3d        ! Logical switch for velocity (u,v) obs
-      LOGICAL :: ln_nea          ! Logical switch to remove obs near land
-      LOGICAL :: ln_altbias      ! Logical switch for altimeter bias
-      LOGICAL :: ln_sstbias      ! Logical switch for bias corection of SST 
-      LOGICAL :: ln_ignmis       ! Logical switch for ignoring missing files
-      LOGICAL :: ln_s_at_t       ! Logical switch to compute model S at T obs
-      LOGICAL :: ln_bound_reject ! Logical to remove obs near boundaries in LAMs.
-      LOGICAL :: llvar1          ! Logical for profile variable 1
-      LOGICAL :: llvar2          ! Logical for profile variable 1
-      LOGICAL, DIMENSION(jpmaxnfiles) :: lmask ! Used for finding number of sstbias files
+      LOGICAL, DIMENSION(:), ALLOCATABLE :: llvar
       !
-      REAL(dp) :: rn_dobsini     ! Obs window start date YYYYMMDD.HHMMSS
-      REAL(dp) :: rn_dobsend     ! Obs window end date   YYYYMMDD.HHMMSS
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zglam1, zglam2   ! Model longitudes for profile variable 1 & 2
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zgphi1, zgphi2   ! Model latitudes  for profile variable 1 & 2
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zmask1, zmask2   ! Model land/sea mask associated with variable 1 & 2
-      !!
-      NAMELIST/namobs/ln_diaobs, ln_t3d, ln_s3d, ln_sla,              &
-         &            ln_sst, ln_sic, ln_sss, ln_vel3d,               &
-         &            ln_altbias, ln_sstbias, ln_nea,                 &
-         &            ln_grid_global, ln_grid_search_lookup,          &
-         &            ln_ignmis, ln_s_at_t, ln_bound_reject,          &
-         &            ln_sstnight,                                    &
-         &            ln_sla_fp_indegs, ln_sst_fp_indegs,             &
-         &            ln_sss_fp_indegs, ln_sic_fp_indegs,             &
-         &            cn_profbfiles, cn_slafbfiles,                   &
-         &            cn_sstfbfiles, cn_sicfbfiles,                   &
-         &            cn_velfbfiles, cn_sssfbfiles,                   &
-         &            cn_sstbiasfiles, cn_altbiasfile,                &
-         &            cn_gridsearchfile, rn_gridsearchres,            &
-         &            rn_dobsini, rn_dobsend,                         &
-         &            rn_sla_avglamscl, rn_sla_avgphiscl,             &
-         &            rn_sst_avglamscl, rn_sst_avgphiscl,             &
-         &            rn_sss_avglamscl, rn_sss_avgphiscl,             &
-         &            rn_sic_avglamscl, rn_sic_avgphiscl,             &
-         &            nn_1dint, nn_2dint,                             &
-         &            nn_2dint_sla, nn_2dint_sst,                     &
-         &            nn_2dint_sss, nn_2dint_sic,                     &
-         &            nn_msshc, rn_mdtcorr, rn_mdtcutoff,             &
-         &            nn_profdavtypes
+      REAL(dp) :: rn_dobsini      ! Obs window start date YYYYMMDD.HHMMSS
+      REAL(dp) :: rn_dobsend      ! Obs window end date   YYYYMMDD.HHMMSS
+      !!
+      NAMELIST/namobs/ln_diaobs, nn_obsgroups,               &
+         &            ln_grid_global, ln_grid_search_lookup, &
+         &            cn_gridsearchfile, rn_gridsearchres,   &
+         &            rn_dobsini, rn_dobsend
       !-----------------------------------------------------------------------
 
@@ -187,14 +117,5 @@
       ! Read namelist parameters
       !-----------------------------------------------------------------------
-      ! Some namelist arrays need initialising
-      cn_profbfiles  (:) = ''
-      cn_slafbfiles  (:) = ''
-      cn_sstfbfiles  (:) = ''
-      cn_sicfbfiles  (:) = ''
-      cn_velfbfiles  (:) = ''
-      cn_sssfbfiles  (:) = ''
-      cn_sstbiasfiles(:) = ''
-      nn_profdavtypes(:) = -1
-
+      ! Initialise time window
       CALL ini_date( rn_dobsini )
       CALL fin_date( rn_dobsend )
@@ -220,156 +141,50 @@
          WRITE(numout,*) 'dia_obs_init : Observation diagnostic initialization'
          WRITE(numout,*) '~~~~~~~~~~~~'
-         WRITE(numout,*) '   Namelist namobs : set observation diagnostic parameters' 
-         WRITE(numout,*) '      Logical switch for T profile observations                ln_t3d = ', ln_t3d
-         WRITE(numout,*) '      Logical switch for S profile observations                ln_s3d = ', ln_s3d
-         WRITE(numout,*) '      Logical switch for SLA observations                      ln_sla = ', ln_sla
-         WRITE(numout,*) '      Logical switch for SST observations                      ln_sst = ', ln_sst
-         WRITE(numout,*) '      Logical switch for Sea Ice observations                  ln_sic = ', ln_sic
-         WRITE(numout,*) '      Logical switch for velocity observations               ln_vel3d = ', ln_vel3d
-         WRITE(numout,*) '      Logical switch for SSS observations                      ln_sss = ', ln_sss
+         WRITE(numout,*) '   Namelist namobs : set observation diagnostic parameters'
+         WRITE(numout,*) '      Number of namobs_dta namelists to read             nn_obsgroups = ', nn_obsgroups
          WRITE(numout,*) '      Global distribution of observations              ln_grid_global = ', ln_grid_global
          WRITE(numout,*) '      Logical switch for obs grid search lookup ln_grid_search_lookup = ', ln_grid_search_lookup
-         IF (ln_grid_search_lookup) &
+         IF (ln_grid_search_lookup) THEN
             WRITE(numout,*) '      Grid search lookup file header                cn_gridsearchfile = ', cn_gridsearchfile
-         WRITE(numout,*) '      Initial date in window YYYYMMDD.HHMMSS               rn_dobsini = ', rn_dobsini
-         WRITE(numout,*) '      Final date in window YYYYMMDD.HHMMSS                 rn_dobsend = ', rn_dobsend
-         WRITE(numout,*) '      Type of vertical interpolation method                  nn_1dint = ', nn_1dint
-         WRITE(numout,*) '      Type of horizontal interpolation method                nn_2dint = ', nn_2dint
-         WRITE(numout,*) '      Rejection of observations near land switch               ln_nea = ', ln_nea
-         WRITE(numout,*) '      Rejection of obs near open bdys                 ln_bound_reject = ', ln_bound_reject
-         WRITE(numout,*) '      MSSH correction scheme                                 nn_msshc = ', nn_msshc
-         WRITE(numout,*) '      MDT  correction                                      rn_mdtcorr = ', rn_mdtcorr
-         WRITE(numout,*) '      MDT cutoff for computed correction                 rn_mdtcutoff = ', rn_mdtcutoff
-         WRITE(numout,*) '      Logical switch for alt bias                          ln_altbias = ', ln_altbias
-         WRITE(numout,*) '      Logical switch for sst bias                          ln_sstbias = ', ln_sstbias
-         WRITE(numout,*) '      Logical switch for ignoring missing files             ln_ignmis = ', ln_ignmis
-         WRITE(numout,*) '      Daily average types                             nn_profdavtypes = ', nn_profdavtypes
-         WRITE(numout,*) '      Logical switch for night-time SST obs               ln_sstnight = ', ln_sstnight
+            WRITE(numout,*) '      Grid search resolution                         rn_gridsearchres = ', rn_gridsearchres
+         ENDIF
       ENDIF
-      !-----------------------------------------------------------------------
-      ! Set up list of observation types to be used
-      ! and the files associated with each type
-      !-----------------------------------------------------------------------
-
-      nproftypes = COUNT( (/ln_t3d .OR. ln_s3d, ln_vel3d /) )
-      nsurftypes = COUNT( (/ln_sla, ln_sst, ln_sic, ln_sss /) )
-
-      IF( ln_sstbias ) THEN 
-         lmask(:) = .FALSE. 
-         WHERE( cn_sstbiasfiles(:) /= '' )   lmask(:) = .TRUE. 
-         jnumsstbias = COUNT(lmask) 
-         lmask(:) = .FALSE. 
-      ENDIF      
-
-      IF( nproftypes == 0 .AND. nsurftypes == 0 ) THEN
-         CALL ctl_warn( 'dia_obs_init: ln_diaobs is set to true, but all obs operator logical flags',   &
-            &           ' (ln_t3d, ln_s3d, ln_sla, ln_sst, ln_sic, ln_vel3d)',                          &
-            &           ' are set to .FALSE. so turning off calls to dia_obs'  )
+
+      IF( ln_grid_global ) THEN
+         CALL ctl_warn( 'dia_obs_init: ln_grid_global=T may cause memory issues when used with a large number of processors' )
+      ENDIF
+
+      !-----------------------------------------------------------------------
+      ! Read namobs_dta namelists and set up observation groups
+      !-----------------------------------------------------------------------
+
+      IF( nn_obsgroups == 0 ) THEN
+         CALL ctl_warn( 'dia_obs_init: ln_diaobs is set to true, but nn_obsgroups == 0',   &
+            &           ' so turning off calls to dia_obs'  )
          ln_diaobs = .FALSE.
          RETURN
       ENDIF
 
-      IF( nproftypes > 0 ) THEN
-         !
-         ALLOCATE( cobstypesprof(nproftypes)             )
-         ALLOCATE( ifilesprof   (nproftypes)             )
-         ALLOCATE( clproffiles  (nproftypes,jpmaxnfiles) )
-         !
-         jtype = 0
-         IF( ln_t3d .OR. ln_s3d ) THEN
-            jtype = jtype + 1
-            CALL obs_settypefiles( nproftypes, jpmaxnfiles, jtype, 'prof  ', &
-               &                   cn_profbfiles, ifilesprof, cobstypesprof, clproffiles )
+      ALLOCATE( sobsgroups(nn_obsgroups) )
+
+      jenabled = 0
+      DO jgroup = 1, nn_obsgroups
+         CALL obs_group_read_namelist( sobsgroups(jgroup) )
+         CALL obs_group_check( sobsgroups(jgroup), jgroup )
+         IF (sobsgroups(jgroup)%lenabled) THEN
+            jenabled = jenabled + 1
          ENDIF
-         IF( ln_vel3d ) THEN
-            jtype = jtype + 1
-            CALL obs_settypefiles( nproftypes, jpmaxnfiles, jtype, 'vel   ', &
-               &                   cn_velfbfiles, ifilesprof, cobstypesprof, clproffiles )
-         ENDIF
-         !
-      ENDIF
-
-      IF( nsurftypes > 0 ) THEN
-         !
-         ALLOCATE( cobstypessurf(nsurftypes)             )
-         ALLOCATE( ifilessurf   (nsurftypes)             )
-         ALLOCATE( clsurffiles  (nsurftypes,jpmaxnfiles) )
-         ALLOCATE( n2dintsurf   (nsurftypes)             )
-         ALLOCATE( zavglamscl   (nsurftypes)             )
-         ALLOCATE( zavgphiscl   (nsurftypes)             )
-         ALLOCATE( lfpindegs    (nsurftypes)             )
-         ALLOCATE( llnightav    (nsurftypes)             )
-         !
-         jtype = 0
-         IF( ln_sla ) THEN
-            jtype = jtype + 1
-            CALL obs_settypefiles( nsurftypes, jpmaxnfiles, jtype, 'sla   ', &
-               &                   cn_slafbfiles, ifilessurf, cobstypessurf, clsurffiles )
-            CALL obs_setinterpopts( nsurftypes, jtype, 'sla   ',      &
-               &                  nn_2dint, nn_2dint_sla,             &
-               &                  rn_sla_avglamscl, rn_sla_avgphiscl, &
-               &                  ln_sla_fp_indegs, .FALSE.,          &
-               &                  n2dintsurf, zavglamscl, zavgphiscl, &
-               &                  lfpindegs, llnightav )
-         ENDIF
-         IF( ln_sst ) THEN
-            jtype = jtype + 1
-            CALL obs_settypefiles( nsurftypes, jpmaxnfiles, jtype, 'sst   ', &
-               &                   cn_sstfbfiles, ifilessurf, cobstypessurf, clsurffiles )
-            CALL obs_setinterpopts( nsurftypes, jtype, 'sst   ',      &
-               &                  nn_2dint, nn_2dint_sst,             &
-               &                  rn_sst_avglamscl, rn_sst_avgphiscl, &
-               &                  ln_sst_fp_indegs, ln_sstnight,      &
-               &                  n2dintsurf, zavglamscl, zavgphiscl, &
-               &                  lfpindegs, llnightav )
-         ENDIF
-#if defined key_si3 || defined key_cice
-         IF( ln_sic ) THEN
-            jtype = jtype + 1
-            CALL obs_settypefiles( nsurftypes, jpmaxnfiles, jtype, 'sic   ', &
-               &                   cn_sicfbfiles, ifilessurf, cobstypessurf, clsurffiles )
-            CALL obs_setinterpopts( nsurftypes, jtype, 'sic   ',      &
-               &                  nn_2dint, nn_2dint_sic,             &
-               &                  rn_sic_avglamscl, rn_sic_avgphiscl, &
-               &                  ln_sic_fp_indegs, .FALSE.,          &
-               &                  n2dintsurf, zavglamscl, zavgphiscl, &
-               &                  lfpindegs, llnightav )
-         ENDIF
-#endif
-         IF( ln_sss ) THEN
-            jtype = jtype + 1
-            CALL obs_settypefiles( nsurftypes, jpmaxnfiles, jtype, 'sss   ', &
-               &                   cn_sssfbfiles, ifilessurf, cobstypessurf, clsurffiles )
-            CALL obs_setinterpopts( nsurftypes, jtype, 'sss   ',      &
-               &                  nn_2dint, nn_2dint_sss,             &
-               &                  rn_sss_avglamscl, rn_sss_avgphiscl, &
-               &                  ln_sss_fp_indegs, .FALSE.,          &
-               &                  n2dintsurf, zavglamscl, zavgphiscl, &
-               &                  lfpindegs, llnightav )
-         ENDIF
-         !
-      ENDIF
-
-
-      !-----------------------------------------------------------------------
-      ! Obs operator parameter checking and initialisations
-      !-----------------------------------------------------------------------
-      !
-      IF( ln_vel3d  .AND.  .NOT.ln_grid_global ) THEN
-         CALL ctl_stop( 'Velocity data only works with ln_grid_global=.true.' )
+      END DO
+
+      IF( jenabled == 0 ) THEN
+         CALL ctl_warn( 'dia_obs_init: ln_diaobs is set to true, and nn_obsgroups > 0',   &
+            &           ' but no groups are enabled so turning off calls to dia_obs'  )
+         ln_diaobs = .FALSE.
          RETURN
       ENDIF
-      !
-      IF( ln_grid_global ) THEN
-         CALL ctl_warn( 'dia_obs_init: ln_grid_global=T may cause memory issues when used with a large number of processors' )
-      ENDIF
-      !
-      IF( nn_1dint < 0  .OR.  nn_1dint > 1 ) THEN
-         CALL ctl_stop('dia_obs_init: Choice of vertical (1D) interpolation method is not available')
-      ENDIF
-      !
-      IF( nn_2dint < 0  .OR.  nn_2dint > 6  ) THEN
-         CALL ctl_stop('dia_obs_init: Choice of horizontal (2D) interpolation method is not available')
-      ENDIF
+
+      !-----------------------------------------------------------------------
+      ! Obs operator parameter checking and initialisations
+      !-----------------------------------------------------------------------
       !
       CALL obs_typ_init
